<?php
require_once("../../config/config_dir_raiz.php");
$config = new Config();
require_once($config->diretorio_raiz()."/src/controller/Funcoes_bd.php");
require_once($config->diretorio_raiz()."/src/model/Bi_conteudo_filtro.php");
require_once($config->diretorio_raiz()."/src/model/bd/Bi_analiseDAO.php");
class Bi_conteudo_filtroDAO
{
	private $_funcoes_bd;
	private $_banco_atual;
	private $conexao;
	function __construct()
	{
		$this->conexao = Conexao::obterConexao();
		$this->_banco_atual = Conexao::getUtilizarBanco();
		$this->_funcoes_bd = new Funcoes_bd();
	}
	public function salvar($bi_conteudo_filtro)
	{
		$inputs = array();
		if($bi_conteudo_filtro->getCodigo() != "")
		{
			array_push($inputs, array('campo'=>':codigo', 'valor'=>$bi_conteudo_filtro->getCodigo()));
		}
		else
		{
			array_push($inputs, array('campo'=>':codigo', 'valor'=>null));
		}
		if($bi_conteudo_filtro->getAnalise() != "")
		{
			array_push($inputs, array('campo'=>':analise', 'valor'=>$bi_conteudo_filtro->getAnalise()));
		}
		else
		{
			array_push($inputs, array('campo'=>':analise', 'valor'=>null));
		}
		if($bi_conteudo_filtro->getId_filtro() != "")
		{
			array_push($inputs, array('campo'=>':id_filtro', 'valor'=>$bi_conteudo_filtro->getId_filtro()));
		}
		else
		{
			array_push($inputs, array('campo'=>':id_filtro', 'valor'=>null));
		}
		if($bi_conteudo_filtro->getTipo() != "")
		{
			array_push($inputs, array('campo'=>':tipo', 'valor'=>$bi_conteudo_filtro->getTipo()));
		}
		else
		{
			array_push($inputs, array('campo'=>':tipo', 'valor'=>null));
		}
		if($bi_conteudo_filtro->getConteudo() != "")
		{
			array_push($inputs, array('campo'=>':conteudo', 'valor'=>$bi_conteudo_filtro->getConteudo()));
		}
		else
		{
			array_push($inputs, array('campo'=>':conteudo', 'valor'=>null));
		}
		try
		{
			$sql = "INSERT INTO bi_conteudo_filtro (codigo, analise, id_filtro, tipo, conteudo) VALUES (:codigo, :analise, :id_filtro, :tipo, :conteudo)  ";
			return $this->_funcoes_bd->executarSql($sql,$inputs);
		}
		catch (Exception $e)
		{
			throw new Exception($e->getMessage());
		}
	}
	public function buscarBi_conteudo_filtro($codigo)
	{
		$inputs = array();
		array_push($inputs, array('campo'=>':codigo', 'valor'=>$codigo));
		$sql = "SELECT * FROM bi_conteudo_filtro where codigo = :codigo "; 
		$bi_conteudo_filtro = new Bi_conteudo_filtro();
		$rows_bi_conteudo_filtro = $this->_funcoes_bd->sqlArrayInputs($sql, $inputs);
		foreach ($rows_bi_conteudo_filtro as $row)
		{
			$bi_conteudo_filtro->setCodigo($row['codigo']);
			if($row['analise'] != "")
			{
				$analiseDAO = new Bi_analiseDAO();
				$bi_conteudo_filtro->setAnalise($analiseDAO->buscarBi_analise($row['analise']));
			}
			else
			{
				$bi_conteudo_filtro->setAnalise(new Bi_analise());
			}
			$bi_conteudo_filtro->setId_filtro($row['id_filtro']);
			$bi_conteudo_filtro->setTipo($row['tipo']);
			$bi_conteudo_filtro->setConteudo($row['conteudo']);
		}
		return $bi_conteudo_filtro;
	}
	public function buscarFiltro($where)
	{
		$inputs = array();
		$sql = "SELECT * FROM bi_conteudo_filtro  ".$where;
		$lista_bi_conteudo_filtro = array();
		$rows_bi_conteudo_filtro = $this->_funcoes_bd->sql($sql);
		foreach ($rows_bi_conteudo_filtro as $row)
		{
			$bi_conteudo_filtro = new Bi_conteudo_filtro();
			$bi_conteudo_filtro->setCodigo($row['codigo']);
			if($row['analise'] != "")
			{
				$analiseDAO = new Bi_analiseDAO();
				$bi_conteudo_filtro->setAnalise($analiseDAO->buscarBi_analise($row['analise']));
			}
			else
			{
				$bi_conteudo_filtro->setAnalise(new Bi_analise());
			}
			$bi_conteudo_filtro->setId_filtro($row['id_filtro']);
			$bi_conteudo_filtro->setTipo($row['tipo']);
			$bi_conteudo_filtro->setConteudo($row['conteudo']);
			array_push($lista_bi_conteudo_filtro, $bi_conteudo_filtro);
		}
		return $lista_bi_conteudo_filtro;
	}
	public function atualizar($bi_conteudo_filtro)
	{
		$inputs = array();
		if($bi_conteudo_filtro->getCodigo() != "")
		{
			array_push($inputs, array('campo'=>':codigo', 'valor'=>$bi_conteudo_filtro->getCodigo()));
		}
		else
		{
			array_push($inputs, array('campo'=>':codigo', 'valor'=>null));
		}
		if($bi_conteudo_filtro->getAnalise() != "")
		{
			array_push($inputs, array('campo'=>':analise', 'valor'=>$bi_conteudo_filtro->getAnalise()));
		}
		else
		{
			array_push($inputs, array('campo'=>':analise', 'valor'=>null));
		}
		if($bi_conteudo_filtro->getId_filtro() != "")
		{
			array_push($inputs, array('campo'=>':id_filtro', 'valor'=>$bi_conteudo_filtro->getId_filtro()));
		}
		else
		{
			array_push($inputs, array('campo'=>':id_filtro', 'valor'=>null));
		}
		if($bi_conteudo_filtro->getTipo() != "")
		{
			array_push($inputs, array('campo'=>':tipo', 'valor'=>$bi_conteudo_filtro->getTipo()));
		}
		else
		{
			array_push($inputs, array('campo'=>':tipo', 'valor'=>null));
		}
		if($bi_conteudo_filtro->getConteudo() != "")
		{
			array_push($inputs, array('campo'=>':conteudo', 'valor'=>$bi_conteudo_filtro->getConteudo()));
		}
		else
		{
			array_push($inputs, array('campo'=>':conteudo', 'valor'=>null));
		}
		try
		{
			$sql = "UPDATE  bi_conteudo_filtro  SET codigo = :codigo, analise = :analise, id_filtro = :id_filtro, tipo = :tipo, conteudo = :conteudo WHERE codigo = :codigo  ";
			return $this->_funcoes_bd->executarSql($sql,$inputs);
		}
		catch (Exception $e)
		{
			throw new Exception($e->getMessage());
		}
	}
	public function excluir($bi_conteudo_filtro)
	{
		try
		{
			$sql = "DELETE FROM bi_conteudo_filtro  WHERE codigo =  :codigo ";
			$inputs = array();
			array_push($inputs, array('campo'=>':codigo', 'valor'=>$bi_conteudo_filtro->getCodigo()));
			return $this->_funcoes_bd->executarSql($sql,$inputs);
		}
		catch (Exception $e)
		{
			throw new Exception($e->getMessage());
		}
	}
	public function listarTodosRegistros()
	{
		$inputs = array();
		$sql = "SELECT * FROM bi_conteudo_filtro";
		$listaBi_conteudo_filtro = array();
		$rows_bi_conteudo_filtro = $this->_funcoes_bd->sql($sql);
		foreach ($rows_bi_conteudo_filtro as $row)
		{
			$bi_conteudo_filtro = new Bi_conteudo_filtro();
			$bi_conteudo_filtro->setCodigo($row['codigo']);
			if($row['analise'] != "")
			{
				$analiseDAO = new Bi_analiseDAO();
				$bi_conteudo_filtro->setAnalise($analiseDAO->buscarBi_analise($row['analise']));
			}
			else
			{
				$bi_conteudo_filtro->setAnalise(new Bi_analise());
			}
			$bi_conteudo_filtro->setId_filtro($row['id_filtro']);
			$bi_conteudo_filtro->setTipo($row['tipo']);
			$bi_conteudo_filtro->setConteudo($row['conteudo']);
			array_push($listaBi_conteudo_filtro,$bi_conteudo_filtro );
		}
		return $listaBi_conteudo_filtro;
	}
	public function buscarBi_conteudo_filtroPorAnalise($analise)
	{
		$inputs = array();
		$sql = "SELECT * FROM bi_conteudo_filtro where analise = ".$analise."";
		$lista_bi_conteudo_filtro = array();
		$rows_bi_conteudo_filtro = $this->_funcoes_bd->sql($sql);
		foreach ($rows_bi_conteudo_filtro as $row)
		{
			$bi_conteudo_filtro = new Bi_conteudo_filtro();
			$bi_conteudo_filtro->setCodigo($row['codigo']);
			if($row['analise'] != "")
			{
				$analiseDAO = new Bi_analiseDAO();
				$bi_conteudo_filtro->setAnalise($analiseDAO->buscarBi_analise($row['analise']));
			}
			else
			{
				$bi_conteudo_filtro->setAnalise(new Bi_analise());
			}
			$bi_conteudo_filtro->setId_filtro($row['id_filtro']);
			$bi_conteudo_filtro->setTipo($row['tipo']);
			$bi_conteudo_filtro->setConteudo($row['conteudo']);
			array_push($lista_bi_conteudo_filtro, $bi_conteudo_filtro);
		}
		return $lista_bi_conteudo_filtro;
	}
	public function buscarBi_conteudo_filtroPorId_filtro($id_filtro)
	{
		$inputs = array();
		$sql = "SELECT * FROM bi_conteudo_filtro where id_filtro like '%".$id_filtro."%'";
		$lista_bi_conteudo_filtro = array();
		$rows_bi_conteudo_filtro = $this->_funcoes_bd->sql($sql);
		foreach ($rows_bi_conteudo_filtro as $row)
		{
			$bi_conteudo_filtro = new Bi_conteudo_filtro();
			$bi_conteudo_filtro->setCodigo($row['codigo']);
			if($row['analise'] != "")
			{
				$analiseDAO = new Bi_analiseDAO();
				$bi_conteudo_filtro->setAnalise($analiseDAO->buscarBi_analise($row['analise']));
			}
			else
			{
				$bi_conteudo_filtro->setAnalise(new Bi_analise());
			}
			$bi_conteudo_filtro->setId_filtro($row['id_filtro']);
			$bi_conteudo_filtro->setTipo($row['tipo']);
			$bi_conteudo_filtro->setConteudo($row['conteudo']);
			array_push($lista_bi_conteudo_filtro, $bi_conteudo_filtro);
		}
		return $lista_bi_conteudo_filtro;
	}
	public function buscarBi_conteudo_filtroPorTipo($tipo)
	{
		$inputs = array();
		$sql = "SELECT * FROM bi_conteudo_filtro where tipo like '%".$tipo."%'";
		$lista_bi_conteudo_filtro = array();
		$rows_bi_conteudo_filtro = $this->_funcoes_bd->sql($sql);
		foreach ($rows_bi_conteudo_filtro as $row)
		{
			$bi_conteudo_filtro = new Bi_conteudo_filtro();
			$bi_conteudo_filtro->setCodigo($row['codigo']);
			if($row['analise'] != "")
			{
				$analiseDAO = new Bi_analiseDAO();
				$bi_conteudo_filtro->setAnalise($analiseDAO->buscarBi_analise($row['analise']));
			}
			else
			{
				$bi_conteudo_filtro->setAnalise(new Bi_analise());
			}
			$bi_conteudo_filtro->setId_filtro($row['id_filtro']);
			$bi_conteudo_filtro->setTipo($row['tipo']);
			$bi_conteudo_filtro->setConteudo($row['conteudo']);
			array_push($lista_bi_conteudo_filtro, $bi_conteudo_filtro);
		}
		return $lista_bi_conteudo_filtro;
	}
	public function buscarBi_conteudo_filtroPorConteudo($conteudo)
	{
		$inputs = array();
		$sql = "SELECT * FROM bi_conteudo_filtro where conteudo like '%".$conteudo."%'";
		$lista_bi_conteudo_filtro = array();
		$rows_bi_conteudo_filtro = $this->_funcoes_bd->sql($sql);
		foreach ($rows_bi_conteudo_filtro as $row)
		{
			$bi_conteudo_filtro = new Bi_conteudo_filtro();
			$bi_conteudo_filtro->setCodigo($row['codigo']);
			if($row['analise'] != "")
			{
				$analiseDAO = new Bi_analiseDAO();
				$bi_conteudo_filtro->setAnalise($analiseDAO->buscarBi_analise($row['analise']));
			}
			else
			{
				$bi_conteudo_filtro->setAnalise(new Bi_analise());
			}
			$bi_conteudo_filtro->setId_filtro($row['id_filtro']);
			$bi_conteudo_filtro->setTipo($row['tipo']);
			$bi_conteudo_filtro->setConteudo($row['conteudo']);
			array_push($lista_bi_conteudo_filtro, $bi_conteudo_filtro);
		}
		return $lista_bi_conteudo_filtro;
	}
}